# mklist.tcl
# Test script for Xccm. Feel free to alter as you wish!
# Creates mailing lists for Local users
# Optional mList Name, defaults to MLOCALn
# Fixed vars for poname and path, asks for po password

set poname "Test"
set popath "d:/ccmail/ccdata"

set mlist "MLOCAL"  ;#Name for lists
set maxlist 5       ;#Max names per list

# utility proc to print out line w/o newline
proc print {str} {
puts -nonewline "$str "
flush stdout
}

#check params get first param from list
if {$argc >0} {set mlist "[lindex $argv 0]" }

#load the extension
package require Xccm

#get the password
print "Password for PO $poname?" 
gets stdin popw

#try to log in. Catch the error. Msg if any in retval. 
if {[catch {set handle [ccm_Open $popath $poname $popw] } retval] != 0} {
  puts $retval
  ccm_Stop
  return
}

#create a list of local (L) user names with the N option
set mlocals [ ccm_DirList $handle N ]

set mcount 0    ;#counter of lists
set nusr   0    ;#counter of users
              
set mcurrent "$mlist$mcount"
#delete the mailing list if exists and recreate
catch {ccm_GrpDel $mcurrent}
catch {ccm_GrpAdd $mcurrent}
set nusr 100
# scan through the list
foreach usr $mlocals { 
  incr nusr
  #new list every 100 users
  if {$nusr > $maxlist} {
    incr mcount
    set mcurrent "$mlist$mcount"
    catch {ccm_GrpDel $handle $mcurrent}
    catch {ccm_GrpAdd $handle $mcurrent}
    set nusr 0
  }
  #break loop at first failure
  if {[catch {ccm_GrpAddUsr $handle $mcurrent $usr} retval] !=0} {
    puts $retvaL
    break
  }
  puts "Adding $usr to $mcurrent"
}

ccm_Close $handle
# v-important to call ccm_Stop last thing. It makes sure resources are freed etc.
ccm_Stop
exit
